# ETokensBundleVault

ERC-4626 vault that invests in several eTokens with fixed allocations.

## **Roles**

The roles and functions of the contract are as follows:

| Role                     | Description                                                      | Methods Accessible                                                                                            |
| ------------------------ | ---------------------------------------------------------------- | ------------------------------------------------------------------------------------------------------------- |
| ADMIN\_ROLE              | Adds and removes underlying eTokens.                             | <ul><li>addEToken: Adds a new underlying eToken.</li><li>removeEToken: Removes an underlying eToken</li></ul> |
| CHANGE\_PERCENTAGE\_ROLE | Changes allocation percentages for eTokens.                      | <ul><li>changePercentages: Changes allocation percentages for eTokens.</li></ul>                              |
| REORDER\_ROLE            | Swaps the order of underlying eTokens.                           | <ul><li>reorderETokens: Swaps order of underlying eTokens.</li></ul>                                          |
| REBALANCER\_ROLE         | Moves funds between underlying eTokens for rebalancing purposes. | <ul><li>rebalance: Moves funds between underlying eTokens.</li></ul>                                          |

This contract does not use Access Manager as an access control solution. It has its own [access control ](https://docs.openzeppelin.com/contracts/5.x/api/access)mechanism.


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.ensuro.co/ensuro-docs/smart-contracts/contracts/extensions/etokensbundlevault.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
